[TOC]
# Sample Hardhat Project

- https://hardhat.org/hardhat-runner/docs/guides/project-setup

## I/ Init Hardhat project and run a Hardhat Network

#### 1/ Set up a Hardhat project.

```
mkdir sameple-hardhat-project
cd sameple-hardhat-project
npm init -y
npm install --save-dev hardhat
```

Create a Hardhat project:
```
npx hardhat init
```

#### 2/ Create a new MetaMask seed phrase specifically for development.
- Cài đặt metamask và tạo tài khoản mới, lưu lại `seed phrase` (hay còn gọi là mnemonic code)

#### 3/ In your hardhat.config.js file, specify a networks configuration with a hardhat network. In this networks.hardhat configuration:

Alternatively, to prevent committing your seed phrase, we recommend adding your seed phrase to a `.env` file and using the process.env global variable in `hardhat.config.js.`

- Install `dotenv` module

```bash
npm install dotenv --save
```
- adding your seed phrase to a `.env` file:

```
SEED_PHRASE=your seed phares
```

- In your `hardhat.config.js` file, specify a networks configuration with a hardhat network. In this networks.hardhat configuration:

```
module.exports = {
  networks: {
    hardhat: {
      accounts: {
        mnemonic: process.env.SEED_PHRASE,
      },
      chainId: 1337
    },
  },
};
```

#### 4/ Run Hardhat Network

- Run `npx hardhat node` to run Hardhat Network and expose a JSON-RPC interface.
- You can now connect MetaMask to your Hardhat Network RPC URL, http://127.0.0.1:8545/. In the MetaMask extension:

    - In the upper left corner, select the network you're currently connected to.
    - Select Add network.
    - Select Add a network manually.
    - Enter your Hardhat Network RPC URL, http://127.0.0.1:8545/ (or http://localhost:8545).
    - Enter your Hardhat Network chain ID, 1337 (or 0x539 in hexadecimal format).
> Alternatively, you can add Hardhat Network to MetaMask using wallet_addEthereumChain in the interactive API playground.

- Reset your local nonce calculation: Mỗi lần restart lại blockchain network này, cần phải reset account ở metamask

## II/ Smart contract
#### Example Contract `Lock.sol`

```solidity
// SPDX-License-Identifier: UNLICENSED
pragma solidity ^0.8.9;

// Uncomment this line to use console.log
// import "hardhat/console.sol";

contract Lock {
    uint public unlockTime;
    address payable public owner;

    event Withdrawal(uint amount, uint when);

    constructor(uint _unlockTime) payable {
        require(
            block.timestamp < _unlockTime,
            "Unlock time should be in the future"
        );

        unlockTime = _unlockTime;
        owner = payable(msg.sender);
    }

    function withdraw() public {
        // Uncomment this line, and the import of "hardhat/console.sol", to print a log in your terminal
        // console.log("Unlock time is %o and block timestamp is %o", unlockTime, block.timestamp);

        require(block.timestamp >= unlockTime, "You can't withdraw yet");
        require(msg.sender == owner, "You aren't the owner");

        emit Withdrawal(address(this).balance, block.timestamp);

        owner.transfer(address(this).balance);
    }
}
```
#### Compiling your contracts

```
$ npx hardhat compile
Compiling...
Compiled 1 contract successfully
```

#### Testing contracts

- Source: `test/Lock.js`

```
npx hardhat coverage
```

#### Deploying your contracts
You can deploy in the localhost network following these steps:

1/ Start a local node

```bash
npx hardhat node
```

2/ Open a new terminal and deploy the smart contract in the localhost network

```bash
npx hardhat run --network localhost scripts/deploy.js
```

As general rule, you can target any network from your Hardhat config using:

```bash
npx hardhat run --network <your-network> scripts/deploy.js
```

Example:

```bash
 npx hardhat run --network hardhat  scripts/deploy.js
```

```bash
sample-hardhat-project git:(main) npx hardhat run --network hardhat  scripts/deploy.js
WARNING: You are currently using Node.js v14.19.0, which is not supported by Hardhat. This can lead to unexpected behavior. See https://hardhat.org/nodejs-versions


Compiled 1 Solidity file successfully
Lock with 0.001ETH and unlock timestamp 1696679522 deployed to 0xE9613d7Ec2ED6778331F17BDbc1d19734Bde210e
```
##### Lưu ý:

Bạn cần lưu lại địa chỉ contract đã deploy ở trên, ví dụ ở đây là '0xE9613d7Ec2ED6778331F17BDbc1d19734Bde210e'. Sẽ cần address này để tương tác với smart contract trong phần tiếp theo "III/ Interacting With Smart Contracts Using Web3.js"
#### Verifying your contracts

Verifying a contract means making its source code public, along with the compiler settings you used, which allows anyone to compile it and compare the generated bytecode with the one that is deployed on-chain. Doing this is extremely important in an open platform like Ethereum.

Read more: https://hardhat.org/hardhat-runner/docs/guides/verifying

## III/ Interacting With Smart Contracts Using Web3.js

Next step here: https://gitlab-new.bap.jp/RDC/TRAINING/blockchain/01-web3js-connect-wallet
